--
-- running time:  seconds
--
drop materialized view events_game;

create materialized view events_game
as
select 
	game_id
	, sum(event_runs_ct*bat_home_id) as home_score_ct
	, sum(event_outs_ct*bat_home_id) as home_outs_ct
	, sum(event_runs_ct*(1-bat_home_id)) as away_score_ct
	, sum(event_outs_ct*(1-bat_home_id)) as away_outs_ct
	, case
		when sum(event_runs_ct*bat_home_id) > sum(event_runs_ct*(1-bat_home_id)) 
			then 1 
		when sum(event_runs_ct*bat_home_id) < sum(event_runs_ct*(1-bat_home_id)) 
			then -1
			else 0 
	end as fate_home_score_cd
from	events
group by
	game_id
;
commit;

ALTER table events_game
	ADD CONSTRAINT pk_events_game 
	PRIMARY KEY (game_id)
;

commit;

