--
-- running time: 1.6 minutes
--

select sysdate from dual;

drop materialized view events_inning_partial;

create materialized view events_inning_partial
as
(
	select	
		game_id
		,bat_team_id
		,inn_ct
		,sum(event_outs_ct) as outs_ct
		,max(event_id*10 + e.END_BASES_CD) - max(event_id*10)
		as END_BASES_CD

	from	events e
	
	group by
		game_id
		,bat_team_id
		,inn_ct

	having	sum(event_outs_ct) < 3
)
;

select sysdate from dual;
commit;

select sum(1) from events_inning_partial;

ALTER TABLE EVENTS_INNING_PARTIAL
  ADD CONSTRAINT PK_EVENTS_INNING_PARTIAL PRIMARY KEY (game_id, bat_team_id, inn_ct) 
;


create or replace view events_inning_partial_ext
as
select
	e.*
	,
	case
		when e.END_BASES_CD <=3
			then e.END_BASES_CD
			else e.END_BASES_CD - 1
	end as END_GAIN_BASES_CT
	,
	case
		when e.end_bases_cd in (0)
			then 0
		when e.end_bases_cd in (1,2,4)
			then 1
		when e.end_bases_cd in (3,5,6)
			then 2
		when e.end_bases_cd in (7)
			then 3
			else -1
	end as END_OCC_BASES_CT
	,
	(3 - OUTS_CT)
	*
	(
		case
		when e.END_BASES_CD <=3
			then e.END_BASES_CD
			else e.END_BASES_CD - 1
		end * 8
		+
		case
		when e.end_bases_cd in (0)
			then 0
		when e.end_bases_cd in (1,2,4)
			then 1
		when e.end_bases_cd in (3,5,6)
			then 2
		when e.end_bases_cd in (7)
			then 3
			else -1
		end * 5
	) / 100 as END_RUNS_LOB_CT
from
	events_inning_partial e
;



