--
-- running time: 2:52 minutes
-- 11.5 minutes with the relief tables
--
drop table events_ext cascade constraints;

create table events_ext as
select	e.seq_events
	,e.game_id
	,
	case
		when e.outs_ct + e.EVENT_OUTS_CT > 2
			then 0
			else e.END_BASES_CD
	end as END_BASES_CD
	,
	case
		when e.outs_ct + e.EVENT_OUTS_CT > 2
			then 0
		when e.END_BASES_CD <=3
			then e.END_BASES_CD
			else e.END_BASES_CD - 1
	end as END_GAIN_BASES_CT
	,
-- in this case, we don't trust end_bases_cd at the end of the inning				
	case
		when e.outs_ct + e.EVENT_OUTS_CT > 2
			then (
				case when e.bat_dest_id between 1 and 3 then 1 else 0 end
				+					
				case when e.run1_dest_id between 1 and 3 then 1 else 0 end
				+					
				case when e.run2_dest_id in (2,3) then 1 else 0 end
				+					
				case when e.run3_dest_id = 3 then 1 else 0 end
			)
		when e.end_bases_cd in (0)
			then 0
		when e.end_bases_cd in (1,2,4)
			then 1
		when e.end_bases_cd in (3,5,6)
			then 2
		when e.end_bases_cd in (7)
			then 3
			else -1
	end as END_OCC_BASES_CT
	,
	case
		when e.START_BASES_CD <=3
			then e.START_BASES_CD
			else e.START_BASES_CD - 1
	end as START_GAIN_BASES_CT
	,
	case
		when e.start_bases_cd in (0)
			then 0
		when e.start_bases_cd in (1,2,4)
			then 1
		when e.start_bases_cd in (3,5,6)
			then 2
		when e.start_bases_cd in (7)
			then 3
			else -1
	end as START_OCC_BASES_CT
	,
	case
		when e.event_cd in (2,19)
		and e.event_outs_ct = 0
			then 99 - e.event_cd
			else e.event_cd
	end as event_cd
	,
	case
		when e.start_bases_cd in (1,2,4)
			then 1
			else 0
	end as OPP_FORCE_FL
	,
	case
		when (e.BASE2_FORCE_FL = 'T')
		or (e.BASE3_FORCE_FL = 'T')
		or (e.BASE4_FORCE_FL = 'T')
			then 1
			else 0
	end as FORCE_FL
	,
	case
		when (e.bat_start_fl = 'T')
			then floor(e.GAME_PA_CT/9) 
			else floor((e.GAME_PA_CT - eb.MIN_GAME_PA_CT)/9)
	end as BAT_PA_CT
	,
	case
		when (e.pit_start_fl = 'T')
			then e.GAME_PA_CT 
			else (e.GAME_PA_CT - ep.MIN_GAME_PA_CT)
	end as PIT_PA_CT
	,
	case
		when (e.outs_ct < 2)
		and (e.start_bases_cd > 0)
			then	1
			else	0
	end as OPP_SACBUNT_FL 
	,
	case
		when (e.outs_ct < 2)
		and (e.start_bases_cd > 0)
		and (e.bunt_fl = 'T')
			then	1
			else	0
	end as ATT_SACBUNT_FL
from	events e
	LEFT JOIN
	events_relief_bat eb
		ON	e.game_id = eb.game_id
		AND	e.bat_id = eb.bat_id
	LEFT JOIN
	events_relief_pit ep
		ON	e.game_id = ep.game_id
		AND	e.pit_id = ep.pit_id
;
	
 commit;


ALTER TABLE EVENTS_EXT
  MODIFY (SEQ_EVENTS   NOT NULL)
  ;

 ALTER TABLE events_ext
  ADD CONSTRAINT PK_events_ext 
  PRIMARY KEY (seq_events)
 ;

CREATE INDEX IX_EVENTS_EXT_GAME_ID
 ON EVENTS_EXT(GAME_ID)
;

commit;

