--
-- running time: 7.3 minutes
--
select sysdate from dual;

drop table games_previous cascade constraints;

create table games_previous
as
select
	gl1.game_id
	,gl1.player_id
	,gl1.start_fl
	,gx1.game_dt
	,max(gx2.game_dt) as prev_game_dt
	,max(
		decode(
			gl2.start_fl
			,1,gx2.game_dt
			,null
		)
	) as start_prev_game_dt
	,max(
		decode(
			gl2.start_fl
			,0,gx2.game_dt
			,null
		)
	) as relief_prev_game_dt


from
	(
		games_ext gx1
		inner join
		games_lineup gl1
			on gx1.game_id = gl1.game_id
	)
	left join
	(
		games_ext gx2
		inner join
		games_lineup gl2
			on gx2.game_id = gl2.game_id
	) 
		on gl1.game_id <> gl2.game_id
		and gl1.player_id = gl2.player_id
		and substr(gx1.game_id,4,4) = substr(gx2.game_id,4,4)
		and gx1.game_dt >= gx2.game_dt

group by
	gl1.game_id
	,gl1.player_id
	,gl1.start_fl
	,gx1.game_dt
;


select sysdate from dual;


-- testing missing records
select g1.*
from games_lineup g1 left join games_previous g2
on g1.game_id = g2.game_id
and g1.player_id = g2.player_id
where g2.game_id is null
;