

create or replace view YEAR_PARK_RUNS
as
select
	to_char(ge.game_dt,'YYYY') as year_game_dt
	,g.park_id
	,sum(eg.home_score_ct) as home_runs_ct
	,sum(eg.home_outs_ct) as home_outs_ct
	,sum(eg.away_score_ct) as away_runs_ct
	,sum(eg.away_outs_ct) as away_outs_ct
	,sum(decode(eg.fate_home_score_cd,1,1,0)) as home_wins_dec_ct
	,sum(decode(eg.fate_home_score_cd,-1,1,0)) as home_loss_dec_ct
	,sum(decode(eg.fate_home_score_cd,0,1,0)) as home_tie_dec_ct
	,sum(nvl(eipe.END_RUNS_LOB_CT,0)) as END_RUNS_LOB_CT
	,sum(eg.home_score_ct+eg.away_score_ct+nvl(eipe.END_RUNS_LOB_CT,0)) as runs_ct
	,sum(eg.home_outs_ct+eg.away_outs_ct) as outs_ct
	,sum(eg.home_score_ct+eg.away_score_ct+nvl(eipe.END_RUNS_LOB_CT,0))
	/sum(eg.home_outs_ct+eg.away_outs_ct)*27 as pergame_park_runs_ct

from
	events_game eg
	left join
	games g
		on eg.game_id = g.game_id
	left join
	games_ext ge
		on eg.game_id = ge.game_id
	left join
	events_inning_partial_ext eipe
		on eg.game_id = eipe.game_id

group by
	to_char(ge.game_dt,'YYYY') 
	,g.park_id

;
